#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"

#include "itmr.h"

static unsigned int stime2;
static unsigned int period1 = 1000;

void led_Toggle(unsigned char num);
void led_Write(unsigned char num, bool on_off);

void led_Init(void)
{					

	PORT_InitTypeDef PORT_InitStructure;

  RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTB, ENABLE);

  PORT_InitStructure.PORT_Pin   = (PORT_Pin_0 | PORT_Pin_1 | PORT_Pin_2 | PORT_Pin_3 | PORT_Pin_4);
  PORT_InitStructure.PORT_OE    = PORT_OE_OUT;
  PORT_InitStructure.PORT_FUNC  = PORT_FUNC_PORT;
  PORT_InitStructure.PORT_MODE  = PORT_MODE_DIGITAL;
  PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
  PORT_Init(MDR_PORTB, &PORT_InitStructure); 	
	
	stime2 = itmr_GetTick();		
}

void led_Work(void)
{			
		static bool f2 = false;		
		int n;
	
	
		if(itmr_IsTime(stime2, period1)){			
			
			if(f2) f2 = false;
			else f2 = true;			
			
			for(n = 3; n < 4; n++) led_Toggle(n);
			stime2 = itmr_GetTick();
		}			
}

void led_Toggle(unsigned char num)
{
	static bool flags[8] = {false, false, false, false, false, false, false, false};
	
	if(num >= 8) return;
	
	if(flags[num]) flags[num] = false;
	else flags[num] = true;
	switch(num){
		case 0:			
			//PORT_WriteBit(MDR_PORTA, PORT_Pin_2, flags[num] ? Bit_SET : Bit_RESET);
			break;
		case 1:
			//PORT_WriteBit(MDR_PORTA, PORT_Pin_4, flags[num] ? Bit_SET : Bit_RESET);				
			break;
		case 2:
			//PORT_WriteBit(MDR_PORTB, PORT_Pin_5, flags[num] ? Bit_SET : Bit_RESET);			
			break;
		case 3:		
			PORT_WriteBit(MDR_PORTB, PORT_Pin_0, flags[num] ? Bit_SET : Bit_RESET);			
			break;
		case 4:			
			PORT_WriteBit(MDR_PORTB, PORT_Pin_1, flags[num] ? Bit_SET : Bit_RESET);			
			break;
		case 5:			
			PORT_WriteBit(MDR_PORTB, PORT_Pin_2, flags[num] ? Bit_SET : Bit_RESET);				
			break;		
		case 6:			
			PORT_WriteBit(MDR_PORTB, PORT_Pin_3, flags[num] ? Bit_SET : Bit_RESET);			
			break;
		case 7:			
			PORT_WriteBit(MDR_PORTB, PORT_Pin_4, flags[num] ? Bit_SET : Bit_RESET);			
			break;			
		default:			
			break;
	}		
}

void led_Write(unsigned char num, bool on_off)
{
	switch(num){
		case 0:
			//PORT_WriteBit(MDR_PORTA, PORT_Pin_2, on_off ? Bit_SET : Bit_RESET);
			break;
		case 1:
			//PORT_WriteBit(MDR_PORTA, PORT_Pin_4, on_off ? Bit_SET : Bit_RESET);
			break;
		case 2:
			PORT_WriteBit(MDR_PORTB, PORT_Pin_5, on_off ? Bit_SET : Bit_RESET);
			break;
		case 3:
			PORT_WriteBit(MDR_PORTB, PORT_Pin_0, on_off ? Bit_SET : Bit_RESET);
			break;
		case 4:
			PORT_WriteBit(MDR_PORTB, PORT_Pin_1, on_off ? Bit_SET : Bit_RESET);
			break;
		case 5:
			PORT_WriteBit(MDR_PORTB, PORT_Pin_2, on_off ? Bit_SET : Bit_RESET);
			break;		
		case 6:
			PORT_WriteBit(MDR_PORTB, PORT_Pin_3, on_off ? Bit_SET : Bit_RESET);
			break;
		case 7:
			PORT_WriteBit(MDR_PORTB, PORT_Pin_4, on_off ? Bit_SET : Bit_RESET);
			break;			
		default:			
			break;
	}		
}
