#include "MDR32F9Qx_port.h"
#include "MDR32F9Qx_rst_clk.h"
#include "MDR32F9Qx_ssp.h"

#include "mcp23s18.h"
//#include "console.h"
#include "itmr.h"
#include "led.h"
#include "misc.h"
#include "disp.h"

//static int stime, period = 4000;
extern char global_event = 1;
#define ADDR_MCP23S18		0x20
#define READ_CMD	(((ADDR_MCP23S18) << 1) | 1)
#define WRITE_CMD	((ADDR_MCP23S18) << 1)

static void HardwareInit(void)
{	SSP_InitTypeDef sSSP;
	PORT_InitTypeDef PORT_InitStructure;
	
	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_PORTD | RST_CLK_PCLK_PORTE, ENABLE);	
	RST_CLK_PCLKcmd(RST_CLK_PCLK_SSP2, ENABLE);	
	
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
	PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	  
	PORT_InitStructure.PORT_PD = PORT_PD_DRIVER;
	
	PORT_InitStructure.PORT_OE = PORT_OE_IN;	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_ALTER;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	PORT_InitStructure.PORT_Pin = PORT_Pin_2; // SPI  //SPI RX
	PORT_Init(MDR_PORTD, &PORT_InitStructure);
  
	
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;			
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_ALTER;
	PORT_InitStructure.PORT_MODE = PORT_MODE_DIGITAL;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	PORT_InitStructure.PORT_Pin = (PORT_Pin_5 | PORT_Pin_6); // SPI   // 5- CLK 6 - SPI TX
	PORT_Init(MDR_PORTD, &PORT_InitStructure);	
	
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_ON;
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_1); // CS
	PORT_Init(MDR_PORTE, &PORT_InitStructure);	
	
	// ADC PORTS
	PORT_InitStructure.PORT_OE = PORT_OE_IN;	
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
  PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_ANALOG;
	PORT_InitStructure.PORT_SPEED = PORT_SPEED_MAXFAST;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_4|PORT_Pin_7);
	PORT_Init(MDR_PORTD, &PORT_InitStructure);
	
	// DAC PORTS
	PORT_InitStructure.PORT_OE = PORT_OE_OUT;	
	PORT_InitStructure.PORT_PULL_UP = PORT_PULL_UP_OFF;
  PORT_InitStructure.PORT_PULL_DOWN = PORT_PULL_DOWN_OFF;
	
	PORT_InitStructure.PORT_FUNC = PORT_FUNC_PORT;
	PORT_InitStructure.PORT_MODE = PORT_MODE_ANALOG;
	//PORT_InitStructure.PORT_SPEED = PORT_SPEED_SLOW;
	
	PORT_InitStructure.PORT_Pin = (PORT_Pin_0);
	PORT_Init(MDR_PORTE, &PORT_InitStructure);
	
	// SPI
	
	SSP_DeInit(MDR_SSP2);
	SSP_BRGInit(MDR_SSP2,SSP_HCLKdiv8);		//16
	
	SSP_StructInit(&sSSP);

  sSSP.SSP_SCR  = 0x0;  //20
  sSSP.SSP_CPSDVSR = 2;
  sSSP.SSP_Mode = SSP_ModeMaster;
  sSSP.SSP_WordLength = SSP_WordLength8b;
  sSSP.SSP_SPH = SSP_SPH_1Edge;//SSP_SPH_1Edge;
  sSSP.SSP_SPO = SSP_SPO_Low;//SSP_SPO_Low;
  sSSP.SSP_FRF = SSP_FRF_SPI_Motorola;
  sSSP.SSP_HardwareFlowControl = SSP_HardwareFlowControl_SSE;
  SSP_Init (MDR_SSP2, &sSSP);
	SSP_DMACmd(MDR_SSP2, (SSP_DMA_TXE | SSP_DMA_RXE), DISABLE);
	
	SSP_Cmd(MDR_SSP2, ENABLE);	

	
}

unsigned char SendAndRcvByte(unsigned char byte)
{	
	unsigned short rb;
	while (SSP_GetFlagStatus(MDR_SSP2, SSP_FLAG_TFE ) == RESET);
	SSP_SendData(MDR_SSP2, byte);
	while (SSP_GetFlagStatus(MDR_SSP2, SSP_FLAG_RNE ) == RESET);
	rb = SSP_ReceiveData(MDR_SSP2);	
	return rb;
}
unsigned char SSP_SendByte(unsigned char byte)
{while (SSP_GetFlagStatus(MDR_SSP2, SSP_FLAG_TFE ) == RESET);
	SSP_SendData(MDR_SSP2, byte);
	return 0;
}
unsigned char SSP_ReceiveByte(unsigned char byte)
{unsigned short rb;
	while (SSP_GetFlagStatus(MDR_SSP2, SSP_FLAG_RNE ) == RESET);
	rb = SSP_ReceiveData(MDR_SSP2);	
	return rb;
}

void mcp23s18_WriteWord(unsigned char addr, unsigned char data){
	
	PORT_WriteBit(MDR_PORTE, PORT_Pin_1, Bit_RESET);
	
	SendAndRcvByte(MCP23S18WRADDR);	
	
	SendAndRcvByte(addr);	
	
	SendAndRcvByte(data);	//LOW
	
	PORT_WriteBit(MDR_PORTE, PORT_Pin_1, Bit_SET);
}


unsigned short ReadAddress(unsigned char addr){
	unsigned char  l;

	PORT_WriteBit(MDR_PORTE, PORT_Pin_1, Bit_RESET);
	
	SendAndRcvByte(MCP23S18RDADDR);	

	SendAndRcvByte(addr);	

	l = SendAndRcvByte(0);
	
	PORT_WriteBit(MDR_PORTE, PORT_Pin_1, Bit_SET);

	return l;
}

unsigned char mcp23s18_ReadSW3(void)
{	unsigned char bit = 0;
	unsigned short gpio = 0;
	gpio = ReadAddress(GPIOB_BANK0);
	gpio = gpio >> 7;
	bit = gpio;
	return bit;
}

// чтение состояния входов
unsigned short mcp23s18_ReadGPIO(void)
{
	return (ReadAddress(GPIOB_BANK0) << 8) | (ReadAddress(GPIOA_BANK0));  // OLAT - register for outputs, GPIO - register for inputs	
}


unsigned short mcp23s18_PORTS_Init(void)
{	mcp23s18_WriteWord(IOCONA_BANK0, 0x08);
	mcp23s18_WriteWord(IOCONB_BANK0, 0x08);
	mcp23s18_WriteWord(GPPUA_BANK0, 0x00);  //pull-up enable
	mcp23s18_WriteWord(GPPUB_BANK0, 0x00);  //pull-up enable
	mcp23s18_WriteWord(GPIOA_BANK0, 0xFF);  
	mcp23s18_WriteWord(GPIOB_BANK0, 0xFF);  
	
	mcp23s18_WriteWord(IODIRA_BANK0 , 0x00); // if F - inputs, if 0 - outputs
	mcp23s18_WriteWord(IODIRB_BANK0 , 0x80); // if F - inputs, if 0 - outputs
	mcp23s18_WriteWord(INTCONA_BANK0, 0x00);  
	mcp23s18_WriteWord(INTCONB_BANK0, 0x00);  
	mcp23s18_WriteWord(DEFVALA_BANK0, 0x00);  
	mcp23s18_WriteWord(DEFVALB_BANK0, 0x00);
	mcp23s18_WriteWord(GPINTENA_BANK0 , 0x00);  //disable INT
	mcp23s18_WriteWord(GPINTENB_BANK0 , 0x00);  //disable INT
	//mcp23s18_WriteWord(OLATA_BANK0 , 0x00);  //disable INT
	//mcp23s18_WriteWord(OLATB_BANK0 , 0x00);  //disable INT
	return 0;
}
void mcp23s18_WritePORTS(unsigned short port_state)
{ unsigned char porta = (port_state);
	unsigned char portb = ((port_state)>> 8);
	mcp23s18_WriteWord(GPIOA_BANK0, porta);
	mcp23s18_WriteWord(GPIOB_BANK0, portb);
	
}

unsigned char mcp23s18_StartLCD(unsigned char flag, unsigned char crystal, unsigned short gpio_state)
{ unsigned short ports = 0;
	unsigned char porta = 0;
	unsigned char portb = 0;
	
	porta = ReadAddress(GPIOA_BANK0);
	portb = ReadAddress(GPIOB_BANK0);
	if (crystal == 1){		
		LCD_CE1(1);
	}
	else if (crystal == 0) {
		LCD_CE0(1);
	}
	else if (crystal == 2) {		
		LCD_CE1(1);
		LCD_CE0(1);
	}
	
	#ifdef __board_ver_1__
	
	if (global_event == 0)
	{
		porta |= (1 << LCD_LED);		// LED ON		
	}
	else
	{
		porta &= ~(1 << LCD_LED);		// LED OFF		
	}
	mcp23s18_WriteWord(GPIOA_BANK0, porta);
	#endif
	
	#ifdef __board_ver_2__
	if (global_event == 0)
	{
		portb |= (1 << (LCD_LED-8));		// LED ON		
	}
	else
	{
		portb &= ~(1 << (LCD_LED-8));		// LED OFF		
	}
	
	#endif
	
	
	portb &= ~(1<<LCD_E_in_port) & ~(1<<LCD_RW_in_port);	 // LCD_E -> 0
	
	mcp23s18_WriteWord(GPIOB_BANK0, portb);	
	
		if (flag > 0){
			LCD_A0(1);	//A0 -> 1
		}
		else {
			LCD_A0(0);	//A0 -> 0
		}
	//delay(DELAY_160NS);	 	
	portb |= (1<<LCD_E_in_port);
		
		mcp23s18_WriteWord(GPIOB_BANK0, portb);	
	//delay(DELAY_160NS);	
	
	
	#ifdef __board_ver_1__
	ports = (portb << 8) | porta;
	ports &= 0xF807;					// without data
	ports |= (gpio_state << 3);	// data	
	porta = ports;		
	portb = ((ports) >> 8);
	
	mcp23s18_WriteWord(GPIOA_BANK0, porta);
	mcp23s18_WriteWord(GPIOB_BANK0, portb);
	#endif
	#ifdef __board_ver_2__		
			
	mcp23s18_WriteWord(GPIOA_BANK0, gpio_state);
	//mcp23s18_WriteWord(GPIOB_BANK0, portb);
		
	#endif
	
	//delay(DELAY_160NS);	
	if (crystal == 1) {
		LCD_CE1(0);		//CE1	
	}
	else if (crystal == 0) {
		LCD_CE0(0);
	}
	else if (crystal == 2) {
		LCD_CE1(0);		//CE1	
		LCD_CE0(0);
	}
	portb &= ~(1<<LCD_E_in_port);  // LCD_E -> 0	
	mcp23s18_WriteWord(GPIOB_BANK0, portb);
	return 0;
}

void mcp23s18_WriteBit(unsigned char gpio_pin, unsigned char gpio_state)
{	unsigned short ports = 0;
	unsigned char porta = 0;
	unsigned char portb = 0;
	ports = mcp23s18_ReadGPIO();
	ports &= 0xFFFF;
	if (gpio_pin < 16) {
		!gpio_state ? (ports &= ~(1 << (gpio_pin))):(ports |= (1 << (gpio_pin)));
	}
	porta = ports;
	portb = (ports >> 8);
	
	if (gpio_pin < 8) {
		  
			mcp23s18_WriteWord(GPIOA_BANK0, porta);
	}
	else
	{ 
		mcp23s18_WriteWord(GPIOB_BANK0, portb);
	}
 
}
void mcp23s18_Init(void)
{ 
	HardwareInit();
  mcp23s18_PORTS_Init();	
	
}
